urllib/urllib2 is incompatible for python 3

Bug #1280105 reported by Fengqian on 2014-02-14
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ceilometer
Undecided
Fengqian
Cinder
Undecided
Fengqian
Fuel for OpenStack
Low
LiuNanke
Glance
Undecided
Fengqian
Magnum
Undecided
Swapnil Kulkarni
Manila
Low
Swapnil Kulkarni
OpenStack DBaaS (Trove)
Low
Victor Stinner
OpenStack Dashboard (Horizon)
Low
Fengqian
OpenStack Object Storage (swift)
Undecided
Hanxi Liu
Sahara
Low
Fengqian
Zuul
In Progress
Undecided
Fengqian
neutron
Undecided
Cyril Roelandt
python-troveclient
Undecided
LiuNanke
refstack
Undecided
Swapnil Kulkarni
tacker
Low
zhangguoqing
tempest
Undecided
Yatin Kumbhare

Bug Description

urllib/urllib2 is incompatible for python 3

Fengqian (fengqian-gao) on 2014-02-14
Changed in ceilometer:
assignee: nobody → Fengqian (fengqian-gao)
Changed in cinder:
assignee: nobody → Fengqian (fengqian-gao)
Changed in glance:
assignee: nobody → Fengqian (fengqian-gao)
Changed in horizon:
assignee: nobody → Fengqian (fengqian-gao)
Fengqian (fengqian-gao) on 2014-02-14
Changed in neutron:
assignee: nobody → Fengqian (fengqian-gao)
Changed in nova:
assignee: nobody → Fengqian (fengqian-gao)
Changed in python-cinderclient:
assignee: nobody → Fengqian (fengqian-gao)
Changed in savanna:
assignee: nobody → Fengqian (fengqian-gao)
Changed in trove:
assignee: nobody → Fengqian (fengqian-gao)
Fengqian (fengqian-gao) on 2014-02-14
Changed in zuul:
assignee: nobody → Fengqian (fengqian-gao)
Fengqian (fengqian-gao) on 2014-02-14
Changed in ceilometer:
status: New → In Progress
Fengqian (fengqian-gao) on 2014-02-14
Changed in cinder:
status: New → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/73961

Changed in neutron:
status: New → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/73967

Changed in savanna:
status: New → In Progress
Fengqian (fengqian-gao) on 2014-02-17
Changed in trove:
status: New → In Progress
Fengqian (fengqian-gao) on 2014-02-17
no longer affects: python-cinderclient
Fengqian (fengqian-gao) on 2014-02-18
Changed in zuul:
status: New → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/74267

Changed in horizon:
status: New → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/74273

Changed in glance:
status: New → In Progress

Reviewed: https://review.openstack.org/73541
Committed: https://git.openstack.org/cgit/openstack/ceilometer/commit/?id=18027816d39743184e45b86371573e574fb12a99
Submitter: Jenkins
Branch: master

commit 18027816d39743184e45b86371573e574fb12a99
Author: Fengqian Gao <email address hidden>
Date: Fri Feb 14 16:12:10 2014 +0800

    Keep py3.X compatibility for urllib.urlencode

    For py3.X, urllib has no attr urlencode while python 2 has.
    Change urlencode to keep compatibility.

    Partial-Bug: #1280105

    Change-Id: I2c0447af3206cdfc55ba22748b2793de8eb94cfb

Changed in savanna:
importance: Undecided → Low
milestone: none → icehouse-3

Reviewed: https://review.openstack.org/73967
Committed: https://git.openstack.org/cgit/openstack/savanna/commit/?id=087e37c972ca8a58412241bebd0e32bafe4f00ea
Submitter: Jenkins
Branch: master

commit 087e37c972ca8a58412241bebd0e32bafe4f00ea
Author: Fengqian Gao <email address hidden>
Date: Mon Feb 17 16:18:24 2014 +0800

    Keep py3.X compatibility for urllib

    Use six.moves.urllib.parse instead of urllib

    Partial-Bug: #1280105

    Change-Id: I1f3fc34af98f60bd162b71d9a71afbc05affb1bf

Fengqian (fengqian-gao) on 2014-02-25
Changed in tempest:
assignee: nobody → Fengqian (fengqian-gao)
status: New → In Progress

Reviewed: https://review.openstack.org/74273
Committed: https://git.openstack.org/cgit/openstack/glance/commit/?id=6013c0b68827e6ffbb258e5d407cde10b276cf48
Submitter: Jenkins
Branch: master

commit 6013c0b68827e6ffbb258e5d407cde10b276cf48
Author: Fengqian Gao <email address hidden>
Date: Tue Feb 18 13:44:31 2014 +0800

    Keep py3.X compatibility for urllib

    Use six.moves.urllib.parse instead of urllib

    Partial-Bug: #1280105

    Change-Id: Id08fd5b4dad35c888f302a69be56252fe8276bcb

Reviewed: https://review.openstack.org/74267
Committed: https://git.openstack.org/cgit/openstack/horizon/commit/?id=b7d5a6e74955968688482dac67d65ab7bb20a35a
Submitter: Jenkins
Branch: master

commit b7d5a6e74955968688482dac67d65ab7bb20a35a
Author: Fengqian Gao <email address hidden>
Date: Tue Feb 18 12:57:30 2014 +0800

    Keep py3.X compatibility for urllib

    Use six.moves.urllib.parse instead of urllib

    Partial-Bug: #1280105

    Change-Id: Ie10e9fd8ff42b65b1610839eaeee09e3c56f2de7

Joe Gordon (jogo) on 2014-02-26
Changed in nova:
status: New → Invalid
Fengqian (fengqian-gao) on 2014-02-27
Changed in nova:
status: Invalid → In Progress
Fengqian (fengqian-gao) on 2014-02-27
Changed in nova:
status: In Progress → Invalid
Fengqian (fengqian-gao) wrote :

For nova, urllib can be replaced by six.moves.urllib.parse.

But urllib2 can not be replaced by six.moves.urllib.request for now, we need to sync policy module from oslo first. Because the old version oslo policy code still use urllib2, it will failed some test cases.

So, we just replace urllib first.

--fengqian

Changed in nova:
status: Invalid → In Progress
Changed in savanna:
milestone: icehouse-3 → none
Fengqian (fengqian-gao) on 2014-03-06
Changed in ceilometer:
status: In Progress → Fix Committed
Changed in savanna:
status: In Progress → Fix Committed
Changed in glance:
status: In Progress → Fix Committed
Changed in horizon:
status: In Progress → Fix Committed
Akihiro Motoki (amotoki) on 2014-03-22
Changed in horizon:
importance: Undecided → Low
milestone: none → icehouse-rc1
Thierry Carrez (ttx) on 2014-03-27
Changed in ceilometer:
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-03-31
Changed in horizon:
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-04-01
Changed in glance:
milestone: none → icehouse-rc1
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-04-04
Changed in sahara:
milestone: none → icehouse-rc1
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-04-17
Changed in horizon:
milestone: icehouse-rc1 → 2014.1
Thierry Carrez (ttx) on 2014-04-17
Changed in glance:
milestone: icehouse-rc1 → 2014.1
Thierry Carrez (ttx) on 2014-04-17
Changed in sahara:
milestone: icehouse-rc1 → 2014.1
Changed in trove:
importance: Undecided → Low
Sean Dague (sdague) on 2014-09-15
Changed in nova:
status: In Progress → Confirmed
Changed in nova:
assignee: Fengqian (fengqian-gao) → nobody
tags: added: python3

Change abandoned by Henry Gessau (<email address hidden>) on branch: master
Review: https://review.openstack.org/73961
Reason: Superseded by https://review.openstack.org/197730

Changed in neutron:
assignee: Fengqian (fengqian-gao) → Cyril Roelandt (cyril-roelandt)
status: In Progress → Fix Released
Changed in tempest:
assignee: Fengqian (fengqian-gao) → Harshada Mangesh Kakad (harshada-kakad)

Fix proposed to branch: master
Review: https://review.openstack.org/261034

Changed in nova:
assignee: nobody → Swapnil Kulkarni (coolsvap)
status: Confirmed → In Progress

Fix proposed to branch: master
Review: https://review.openstack.org/261166

Changed in trove:
assignee: Fengqian (fengqian-gao) → Swapnil Kulkarni (coolsvap)

Fix proposed to branch: master
Review: https://review.openstack.org/261203

Changed in tempest:
assignee: Harshada Mangesh Kakad (harshada-kakad) → Swapnil Kulkarni (coolsvap)
Changed in murano:
assignee: nobody → Swapnil Kulkarni (coolsvap)
status: New → In Progress
Changed in magnum:
assignee: nobody → Swapnil Kulkarni (coolsvap)
status: New → In Progress
Changed in manila:
assignee: nobody → Swapnil Kulkarni (coolsvap)
status: New → In Progress
Changed in refstack:
assignee: nobody → Swapnil Kulkarni (coolsvap)
status: New → In Progress
Kirill Zaitsev (kzaitsev) wrote :
Changed in murano:
status: In Progress → Invalid
Changed in murano:
status: Invalid → In Progress

Change abandoned by Swapnil Kulkarni (coolsvap) (<email address hidden>) on branch: master
Review: https://review.openstack.org/261237

Reviewed: https://review.openstack.org/261194
Committed: https://git.openstack.org/cgit/openstack/magnum/commit/?id=d8a34e2d69b21d5e16de15b9c3af733afb7e9e62
Submitter: Jenkins
Branch: master

commit d8a34e2d69b21d5e16de15b9c3af733afb7e9e62
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 12:05:37 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: If6c1b016c726070b5b326296ead933cbd74bd408
    Partial-Bug:#1280105

Reviewed: https://review.openstack.org/261243
Committed: https://git.openstack.org/cgit/openstack/murano-dashboard/commit/?id=9e176b0ad2fce78b57159e485b3076a3bc7431e0
Submitter: Jenkins
Branch: master

commit 9e176b0ad2fce78b57159e485b3076a3bc7431e0
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 15:12:50 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: Iafb19056161b6412a6e791e9b5f3a2060a3f8410
    Partial-Bug:#1280105

Reviewed: https://review.openstack.org/261166
Committed: https://git.openstack.org/cgit/openstack/trove/commit/?id=a31867f5e68f57394b1e376962d6e1f544e516ba
Submitter: Jenkins
Branch: master

commit a31867f5e68f57394b1e376962d6e1f544e516ba
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 11:14:16 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: I40edeea4f8320d52472466c6f6832f19f8bd79f0
    Partial-Bug:#1280105

Reviewed: https://review.openstack.org/261196
Committed: https://git.openstack.org/cgit/openstack/manila/commit/?id=67b47906e77930aaa2cb9f13910e70314fd29e13
Submitter: Jenkins
Branch: master

commit 67b47906e77930aaa2cb9f13910e70314fd29e13
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 12:11:59 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: Ie53d198bde6569521a02c09c1ac2cd2d3ba789d5
    Partial-Bug:#1280105

Reviewed: https://review.openstack.org/261203
Committed: https://git.openstack.org/cgit/openstack/tempest-lib/commit/?id=ed0f122915890f1ecbc69a2a2942877138567b3c
Submitter: Jenkins
Branch: master

commit ed0f122915890f1ecbc69a2a2942877138567b3c
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 12:20:42 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: I7bfe6e685a71bde7fc079d95af895e20a8c9c088
    Partial-Bug:#1280105

Reviewed: https://review.openstack.org/261200
Committed: https://git.openstack.org/cgit/openstack/neutron/commit/?id=6689724f0e5ec2a9f3f7f64d4954e54ef9fdd554
Submitter: Jenkins
Branch: master

commit 6689724f0e5ec2a9f3f7f64d4954e54ef9fdd554
Author: Swapnil Kulkarni (coolsvap) <email address hidden>
Date: Thu Dec 24 12:14:44 2015 +0530

    Keep py3.X compatibility for urllib

    Change-Id: I463d00865b8f384d22798be4dd86b62f821af67c
    Partial-Bug:#1280105

Changed in tacker:
assignee: nobody → zhangguoqing (474751729-o)

Fix proposed to branch: master
Review: https://review.openstack.org/266242

Changed in tacker:
status: New → In Progress

Reviewed: https://review.openstack.org/260650
Committed: https://git.openstack.org/cgit/openstack/tempest/commit/?id=71f6b974804dfbd92e1cf08b48d842bb19553f3b
Submitter: Jenkins
Branch: master

commit 71f6b974804dfbd92e1cf08b48d842bb19553f3b
Author: Harshada Mangesh Kakad <email address hidden>
Date: Tue Dec 22 09:46:48 2015 -0800

    Keep py3.X compatibility for urllib.urlencode

    For py3.X, urllib has no attr urlencode while python 2 has.
    Change urlencode to keep compatibility.

    Change-Id: I9fc041d6fd8b65d0a19f38ae1915dcb2a1b42553
    Partial-Bug: #1280105

LiuNanke (nanke-liu) on 2016-01-13
Changed in python-troveclient:
assignee: nobody → LiuNanke (nanke-liu)
status: New → In Progress
LiuNanke (nanke-liu) on 2016-01-13
Changed in fuel:
assignee: nobody → LiuNanke (nanke-liu)
status: New → In Progress
Catherine Diep (cdiep) wrote :
Changed in refstack:
status: In Progress → Fix Released
Dmitry Pyzhov (dpyzhov) on 2016-01-18
Changed in fuel:
importance: Undecided → Low
milestone: none → 9.0

Reviewed: https://review.openstack.org/267090
Committed: https://git.openstack.org/cgit/openstack/fuel-web/commit/?id=f707fa6189c596ec1735a683d7ed8b81af0e9639
Submitter: Jenkins
Branch: master

commit f707fa6189c596ec1735a683d7ed8b81af0e9639
Author: LiuNanke <email address hidden>
Date: Thu Jan 14 02:44:29 2016 +0800

    Keep py3.X compatibility for urllib

    Use six.moves.urllib.parse instead of urllib
    Closes-Bug: #1280105

    Change-Id: I861c32fe7333c3d30b5ae395c97df16f6b39f778

Changed in fuel:
status: In Progress → Fix Committed
Changed in tacker:
importance: Undecided → Low
Sean Dague (sdague) wrote :

I really feel like tracking efforts like this with a bug across all of openstack is just silly. We have python3 work as blueprints, urllib is part of that, no extra bug needed.

no longer affects: nova
no longer affects: murano
Changed in manila:
importance: Undecided → Low
status: In Progress → Fix Committed

Reviewed: https://review.openstack.org/266242
Committed: https://git.openstack.org/cgit/openstack/tacker/commit/?id=0663d08fc137054607b40baebbdeea6311ad29f6
Submitter: Jenkins
Branch: master

commit 0663d08fc137054607b40baebbdeea6311ad29f6
Author: zhangguoqing <zhang.guoqing@99cloud.net>
Date: Tue Jan 12 08:26:27 2016 +0000

    Keep py3.X compatibility for urllib

    Co-Authored-By: Swapnil Kulkarni <email address hidden>
    Partial-Bug:#1280105
    Change-Id: I6d8a18d5818707baaeae93a04580c43872279706

Amrith Kumar (amrith) wrote :

Victor is working on this in Trove now

Changed in trove:
assignee: Swapnil Kulkarni (coolsvap) → Victor Stinner (victor-stinner)

Reviewed: https://review.openstack.org/267084
Committed: https://git.openstack.org/cgit/openstack/python-troveclient/commit/?id=8ed42da06b267c41b1c429d1002435dac0f6a0d5
Submitter: Jenkins
Branch: master

commit 8ed42da06b267c41b1c429d1002435dac0f6a0d5
Author: LiuNanke <email address hidden>
Date: Thu Jan 14 02:36:30 2016 +0800

    Keep py3.X compatibility for urllib

    Use six.moves.urllib.parse instead of urllib

    Change-Id: Ia728005ee0af307a7df042f23f0276f922926465
    Closes-Bug: #1280105

Changed in python-troveclient:
status: In Progress → Fix Released

Fix proposed to branch: master
Review: https://review.openstack.org/323280

Changed in tempest:
assignee: Swapnil Kulkarni (coolsvap) → Yatin Kumbhare (yatinkumbhare-c)

Reviewed: https://review.openstack.org/323280
Committed: https://git.openstack.org/cgit/openstack/tempest/commit/?id=2e2c83a52765aad347176366074ec3c94366ad10
Submitter: Jenkins
Branch: master

commit 2e2c83a52765aad347176366074ec3c94366ad10
Author: Yatin Kumbhare <email address hidden>
Date: Mon May 30 22:45:58 2016 +0530

    Keep py3.X compatibility for urllib

    Change-Id: Iba10637688ada66f2e3003cd87bbba7d4db4abc7
    Closes-Bug: #1280105

Changed in tempest:
status: In Progress → Fix Released
Changed in fuel:
status: Fix Committed → Fix Released
Changed in magnum:
status: In Progress → Fix Released

This issue was fixed in the openstack/python-troveclient 2.3.0 release.

Sean McGinnis (sean-mcginnis) wrote :

Has been addressed in cinder by the py3 compatibility work that completed in Mitaka.

Changed in cinder:
status: In Progress → Fix Released
Hanxi Liu (hanxi-liu) on 2016-09-28
no longer affects: swift
Changed in swift:
assignee: nobody → Hanxi Liu (hanxi-liu)

Fix proposed to branch: master
Review: https://review.openstack.org/378203

Changed in swift:
status: New → In Progress

Reviewed: https://review.openstack.org/378203
Committed: https://git.openstack.org/cgit/openstack/swift/commit/?id=52473ea39277f6b3d8e7d77564189da6b1aec7c3
Submitter: Jenkins
Branch: master

commit 52473ea39277f6b3d8e7d77564189da6b1aec7c3
Author: Hanxi Liu <email address hidden>
Date: Wed Sep 28 10:58:30 2016 +0800

    Use six.moves.urllib.parse instead of urllib

    Six urllib parse contains py3's urllib.parse and py2's urllib.
    Replace urllib with six.moves.urllib.parse to keep compatibility.

    Change-Id: Ie67987e4ffb981c2ee70360f7fa9b3fe873c2a96
    Closes-bug: 1280105

Changed in swift:
status: In Progress → Fix Released

This issue was fixed in the openstack/swift 2.11.0 release.

Download full text (78.0 KiB)

Reviewed: https://review.openstack.org/400985
Committed: https://git.openstack.org/cgit/openstack/swift/commit/?id=0c3f8f87104af8717115c5badffd243dbaa1c430
Submitter: Jenkins
Branch: feature/hummingbird

commit 2d25fe6ad3573b2a06b6b3e5e66493d7b0c55693
Author: Tim Burke <email address hidden>
Date: Mon Jul 25 15:06:23 2016 -0700

    Reduce backend requests for SLO If-Match / HEAD requests

    ... by storing SLO Etag and size in sysmeta.

    Previously, we had to GET the manifest for every HEAD or conditional
    request to an SLO. Worse, since SLO PUTs require that we HEAD every
    segment, we'd GET all included sub-SLO manifests. This was necessary so
    we could recompute the large object's Etag and content-length.

    Since we already know both of those during PUT, we'll now store it in
    object sysmeta. This allows us to:

     * satisfy HEAD requests based purely off of the manifest's HEAD
       response, and
     * perform the If-(None-)Match comparison on the object server, without
       any additional subrequests.

    Note that the large object content-length can't just be parsed from
    content-type -- with fast-POST enabled, the content-type coming out of
    the object-server won't necessarily include swift_bytes.

    Also note that we must still fall back to GETting the manifest if the
    sysmeta headers were not found. Otherwise, we'd break existing large
    objects.

    Change-Id: Ia6ad32354105515560b005cea750aa64a88c96f9

commit ae7dddd801e28217d7dc46bd45cd6b621f29340c
Author: Ondřej Nový <email address hidden>
Date: Mon Nov 21 22:13:11 2016 +0100

    Added comment for "user" option in drive-audit config

    Change-Id: I24362826bee85ac3304e9b63504c9465da673014

commit c3e1d847f4b9d6cc6212aae4dc1b1e6dff45fb40
Author: Thiago da Silva <email address hidden>
Date: Thu Nov 17 17:17:00 2016 -0500

    breaking down tests.py into smaller pieces

    tests.py is currently at ~5500 lines of code, it's
    time to break it down into smaller files.

    I started with an easy middleware set of tests
    (i.e., versioned writes, ~600 lines of code ) so I can get
    some feedback. There are more complicated tests that cover
    multiple middlewares for example, it is not so clear where
    those should go.

    Change-Id: I2aa6c18ee5b68d0aae73cc6add8cac6fbf7f33da
    Signed-off-by: Thiago da Silva <email address hidden>

commit 5d7a3a4172f0f11ab870252eec784cf24b247dea
Author: Ondřej Nový <email address hidden>
Date: Sat Nov 19 23:24:30 2016 +0100

    Removed "in-process-" from func env tox name

    This shorten shebang in infra, because we are hitting 128 bytes limit.

    Change-Id: I02477d81b836df71780942189d37d616944c4dce

commit 9ea340256996a03c8c744201297b47a0e91fe65b
Author: Kota Tsuyuzaki <email address hidden>
Date: Fri Nov 18 01:50:11 2016 -0800

    Don't overwrite built-in 'id'

    This is a follow up for https://review.openstack.org/#/c/399237

    'id' is assigned as a builtin function so that we should not use 'id'
    for the local variable name.

    Change-Id: Ic27460d49e68f6cd50bda1d5b3810e01ccb07a37

commit bf...

tags: added: in-feature-hummingbird
Changed in tacker:
milestone: none → ocata-2
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers